@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.DomainThreatMapping

<style>
    tr td:first-child {
        text-align: left;
    }
    .backtolist {
        margin-top: 3px !important;
    }
</style>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Domain Threat Mapping</h1>
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="Domain" asp-area="Master">Back to Menu</a>

            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
            <script>toastr.success('@ViewBag.message')</script>
        }
        else if (ViewBag.error != null)
        {
            <script>toastr.error('@ViewBag.error')</script>
        }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <form asp-area="Master" asp-controller="DomainThreatMapping" asp-action="SubmitDomainThreatMapping"
                          data-ajax="true"
                          data-ajax-method="POST"
                          data-ajax-mode="replace"
                          data-loading-text="loading..."
                          data-ajax-update="#ajaxresult"
                          data-ajax-success="fn_Onsuccess(data,'Master/DomainThreatMapping/Index');"
                          data-ajax-failure="Errmsg(data);"
                          enctype="multipart/form-data" id="form" method="post">
                        <input type="hidden" asp-for="Id" value="0" />
                        <input type="hidden" asp-for="DomainThreatMappingXML" />
                        <div class="row">
                            <div class="col-md-4 col-sm-6 col-xs-12">
                                <label>Risk Domains</label>
                                <div class="select_box m_bottom">
                                    @Html.DropDownListFor(m => m.DomainId, Model.DdlRiskDomain, "Select Risk Domain", new { @class = "form-control m_no", onchange = "ManageCheckbox(this)" })
                                </div>
                            </div>
                            <div class="col-md-4 col-sm-6 col-xs-12 pt-4">
                                <div class="select_box m_bottom">
                                    <input type="text" class="form-control m_no" onkeyup="filterThreat(this)" placeholder="Search here..." />
                                </div>
                            </div>
                        </div>
                        <script>
                            function filterThreat(input) {
                                var val = $(input).val();
                                if (val == '') $('#tblThreat tbody td').removeAttr('hidden');
                                else {
                                    $('#tblThreat tbody td').each(function (i, ele) {
                                        var text = $(ele).text();
                                        if (i == 0) return;
                                        if (text.toLowerCase().includes(val.toLowerCase().trim())) $(ele).removeAttr('hidden');
                                        else $(ele).attr('hidden', 'hidden');
                                    });
                                }
                            }
                        </script>
                        <div class="table_control" hidden style="overflow-y:auto;height:420px" >
                            <table class="table" id="tblThreat" >
                                <thead>
                                    <tr>
                                        <th class="pl-2" style="width:125px">
                                            <input type="checkbox" id="selectAll" onclick="CheckAllChildCheckBox(this)" />
                                            <label for="selectAll">&nbsp; Select All</label>
                                        </th>
                                        <th class="pl-2" style="width:100px">Threat Code</th>
                                        <th class="pl-2">Threat Name</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach (var item in Model.ThreatList)
                                    {
                                <tr>
                                    <td>
                                        <input type="checkbox" class="threatCheckbox" id="ThreatId@(item.ThreatId)" value="@item.ThreatId" onclick="ManageSelectAllCheckBox(this)" />
                                    </td>
                                    <td>
                                        <label for="ThreatId@(item.ThreatId)">@(item.ThreatCode)</label>
                                    </td>
                                    <td>
                                        <label for="ThreatId@(item.ThreatId)">@(item.ThreatName)</label>
                                    </td>
                                </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                        <div class="row hiddenContent pt-2" hidden>
                            <div class="col-1">
                                <button type="button" class="btn btn-info" onclick="PrepareDomainThreatMappingXML()">Submit</button>
                            </div>
                            <div class="col-1">
                                <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-controller="DomainThreatMapping" asp-area="Master" class="btn btn-danger">Cancel</a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</section>
<script>
    function PrepareDomainThreatMappingXML() {
        var DomainThreatMappingXML = [];
        $('.threatCheckbox').each(function (i, v) {
            DomainThreatMappingXML[i] = {
                Status: $(this).prop('checked') ? true : false,
                ThreatId: parseInt($(this).val())
            }
        });
        $('#DomainThreatMappingXML').val(JSON.stringify(DomainThreatMappingXML));
        $('#form').submit();
        toastr.success('saved successfully');

    }
    function ManageCheckbox(select) {
        if (!$(select).val() == '') {
            $('.hiddenContent').removeAttr('hidden');
            $('.table_control').removeAttr('hidden');
            $.getJSON('/Master/DomainThreatMapping/GetThreatByDomainId', { DomainId: $(select).val() }, function (data) {
                debugger;
                if (data.length > 0) {
                    $('#Id').val(1);
                    $.each(data, function (i, v) {
                        $('#ThreatId' + v.threatId).prop('checked', v.status);
                        ManageSelectAllCheckBox();
                    });
                } else {
                    $('#Id').val(0);
                    $('input[type="checkbox"]').prop('checked', false);
                }
            });
        } else {
            $('.hiddenContent').attr('hidden', 'hidden');
            $('input[type="checkbox"]').prop('checked', false);
        }
    }
    function ManageSelectAllCheckBox(checkbox) {
        var length = parseInt($('.threatCheckbox').length);
        var checkedLength = parseInt($('.threatCheckbox:checked').length);
        if (length === checkedLength) {
            $('#selectAll').prop('checked', true);
        } else {
            $('#selectAll').prop('checked', false);
        }
    }
    function CheckAllChildCheckBox(checkbox) {
        if ($(checkbox).prop('checked')) {
            $('.threatCheckbox').prop('checked', true);
        } else {
            $('.threatCheckbox').prop('checked', false);
        }
    }
</script>